noinst_LIBRARIES += libdsm.a

bin_PROGRAMS += vdSM

libdsm_a_CFLAGS = $(CFLAGS) -Wno-unused-parameter -Wno-unused-function \
                  -Wno-missing-field-initializers -Wno-type-limits

libdsm_a_CPPFLAGS = \
        -DDSMAPI_SUPERUSER -DVIRTUAL_DSM \
        -I$(top_srcdir)/external/qpc/include \
        -I$(top_srcdir)/external/qpc/ports/80x86/linux/gnu \
        -I$(top_srcdir)/src \
        -I$(top_srcdir)/src/dsm

libdsm_a_SOURCES = \
        ../src/dsm/access.h \
        ../src/dsm/access.c \
        ../src/dsm/bitset8.h \
        ../src/dsm/button.h \
        ../src/dsm/crc16_ccitt.h \
        ../src/dsm/crc16_ccitt.c \
        ../src/dsm/dsmapi.h \
        ../src/dsm/dsmapi.c \
        ../src/dsm/dsm.h \
        ../src/dsm/group.h \
        ../src/dsm/group.c \
        ../src/dsm/hash.h \
        ../src/dsm/hash.c \
        ../src/dsm/light.h \
        ../src/dsm/light.c \
        ../src/dsm/heating.h \
        ../src/dsm/heating.c \
        ../src/dsm/mmi.h \
        ../src/dsm/mmi.c \
        ../src/dsm/receiver.h \
        ../src/dsm/registers.h \
        ../src/dsm/registers.c \
        ../src/dsm/scene.h \
        ../src/dsm/scene.c \
        ../src/dsm/security.h \
        ../src/dsm/security.c \
        ../src/dsm/selectA.h \
        ../src/dsm/selectA.c \
        ../src/dsm/version.h \
        ../src/dsm/output_channel.h

# flags shared for C and C++
vdSM_CPPFLAGS = \
        -DDSMAPI_SUPERUSER -DVIRTUAL_DSM -I$(top_srcdir)/qpc/include \
        -I$(top_srcdir)/external/qpc/include \
        -I$(top_srcdir)/external/qpc/ports/80x86/linux/gnu \
        -I$(top_srcdir)/src \
        -I$(top_srcdir)/src/dsm \
        -I$(top_builddir)/messages \
        $(SQLITE3_CFLAGS) \
        $(LIBDSUID_CFLAGS) \
        $(DS485_CORE_CFLAGS) \
        $(DS485_NET_CFLAGS) \
        $(AVAHI_CFLAGS) \
        $(LIBCONFIG_CFLAGS) \
        $(PTHREAD_CFLAGS) \
        $(PROTOBUFC_CFLAGS) \
        $(BOOST_CPPFLAGS)

# C only flags
vdSM_CFLAGS = -Wno-type-limits -Wno-pointer-sign -Wno-array-bounds

# type-limits: uint8_t < 256 false positives
# array-bounds: calling macro in dsm subproject

vdSM_SOURCES = \
        ../src/main.cpp \
        ../src/bsp.h \
        ../src/bsp.cpp \
        ../src/channelutil.h \
        ../src/channelutil.c \
        ../src/coordination.h \
        ../src/coordination.c \
        ../src/datamodel.h \
        ../src/datamodel.c \
        ../src/datamodel.sql.h \
        ../src/discovery.h \
        ../src/discovery.c \
        ../src/device-api-proto.h \
        ../src/device-api-proto.c \
        ../src/ds485.h \
        ../src/ds485.cpp \
        ../src/msgutil.h \
        ../src/msgutil.c \
        ../src/properties.h \
        ../src/properties.c \
        ../src/proputils.h \
        ../src/proputils.c \
        ../src/ReconnectingSocket.h \
        ../src/ReconnectingSocket.cpp \
        ../src/role.h \
        ../src/role.c \
        ../src/selectB.h \
        ../src/selectB.c \
        ../src/selectA-socket.h \
        ../src/selectA-socket.c \
        ../src/sockutil.h \
        ../src/sockutil.c \
        ../src/types.h \
        ../src/util.h \
        ../src/util.c \
        ../src/whitelist.h \
        ../src/whitelist.c \
        ../src/vdc/AsioVdcClient.h \
        ../src/vdc/AsioVdcClient.cpp \
        ../src/vdc/VdcFramer.h \
        ../src/vdc/VdcFramer.cpp \
        ../src/vdc/vdc-api-proto.h \
        ../src/vdc/vdc-api-proto.c \
        ../src/vdc/vdcProcessor.h \
        ../src/vdc/vdcProcessor.c

# not $(DS485_CORE_LIBS), we copied the state machine
vdSM_LDADD = \
        libdsm.a \
        libqep.a \
        libqf.a \
        libprotomessages.a \
        $(SQLITE3_LIBS) \
        $(LIBDSUID_LIBS) \
        $(DS485_NET_LIBS) \
        $(AVAHI_LIBS) \
        $(LIBCONFIG_LIBS) \
        $(PROTOBUFC_LIBS) \
        $(BOOST_LDFLAGS) \
        $(BOOST_SYSTEM_LIB) \
        $(BOOST_CHRONO_LIB) \
        $(PTHREAD_CFLAGS) \
        $(PTHREAD_LIBS)
