/*
    Copyright (c) 2016 digitalSTROM AG, Zurich, Switzerland

    This file is part of vdSM.

    vdSM is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License.

    vdSM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vdSM. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

/**
 * C wrapper for asio VDC client code.
 */

#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif

struct vdc_client;

struct vdc_client* AsioVdcClient_new();
void AsioVdcClient_free(struct vdc_client *);
void AsioVdcClient_start(struct vdc_client *, const char *address, const char *port);
bool AsioVdcClient_isOpen(struct vdc_client *);
void AsioVdcClient_reset(struct vdc_client *);
void AsioVdcClient_asyncWriteFrame(struct vdc_client *, const void *, size_t size);

#ifdef __cplusplus
}

#include <boost/asio/io_service.hpp>
void AsioVdcClient_init(boost::asio::io_service& ioService);

#endif
